{$A+,B-,D+,E-,F-,G-,I+,L+,N-,O-,R-,S-,V-,X+}
{$IFDEF VER70}
{$P-,Q-,T-}
{$ENDIF}
unit
  InitAsm;

interface

uses
  Table;

var
  ATP : AsmTablePtr;

procedure InitAsmTable;

implementation

procedure InitAsmTable;
begin
  New(ATP,Init(NumOp));
  with ATP^ do begin
       { opcode name     dst    src   flags    mnemonic }
    Put($0037,'AAA',    $0400, $0400, $0001); { AAA  adjust ASCII addition }
    Put($00D5,'AAD',    $0400, $0400, $0001); { AAD  help!! needs 2 opcode bytes }
    Put($00D4,'AAM',    $0400, $0400, $0001); { AAM   "       "   "   "      " }
    Put($003F,'AAS',    $0400, $0400, $0001); { AAS }
    Put($0014,'ADC',    $0003, $0300, $1005); { ADC acum, immed }
    Put($0080,'ADC',    $000C, $0300, $1095); { ADC reg, immed }
    Put($0010,'ADC',    $0090, $000C, $0405); { ADC memreg, reg }
    Put($0012,'ADC',    $000C, $0090, $2405); { ADC reg, memreg }
    Put($0080,'ADCB',   $0090, $0100, $1091); { ADC memreg, immed8 (byte) }
    Put($0081,'ADCW',   $0090, $0300, $1091); { ADC memreg, immed16 (word) }
    Put($0004,'ADD',    $0003, $0300, $1005); { ADD acum, immed }
    Put($0080,'ADD',    $000C, $0300, $1085); { ADD reg, immed }
    Put($0000,'ADD',    $0090, $000C, $0405); { ADD memreg, reg }
    Put($0002,'ADD',    $000C, $0090, $2405); { ADD reg, memreg }
    Put($0080,'ADDB',   $0090, $0100, $1081); { ADD memreg, immed8 (byte) }
    Put($0081,'ADDW',   $0090, $0300, $1081); { ADD memreg, immed16 (word) }
    Put($0024,'AND',    $0003, $0300, $1005); { AND acum, immed }
    Put($0080,'AND',    $000C, $0300, $10A5); { AND reg, immed }
    Put($0020,'AND',    $0090, $000C, $0405); { AND memreg, reg }
    Put($0022,'AND',    $000C, $0090, $2405); { AND reg, memreg }
    Put($0080,'ANDB',   $0090, $0100, $10A1); { AND memreg, immed8 (byte) }
    Put($0081,'ANDW',   $0090, $0300, $10A1); { AND memreg, immed16 (word) }
    Put($009A,'CALL',   $0300, $0300, $1001); { CALL immed16, immed16 (far) }
    Put($00E8,'CALL',   $1000, $0400, $0201); { CALL disp16 }
    Put($00FF,'CALLF',  $0090, $0400, $0099); { CALLF memreg }
    Put($00FF,'CALLN',  $0090, $0400, $0091); { CALLN memreg }
    Put($0098,'CBW',    $0400, $0400, $0001); { CBW }
    Put($00F8,'CLC',    $0400, $0400, $0001); { CLC }
    Put($00FC,'CLD',    $0400, $0400, $0001); { CLD }
    Put($00FA,'CLI',    $0400, $0400, $0001); { CLI }
    Put($00F5,'CMC',    $0400, $0400, $0001); { CMC }
    Put($003C,'CMP',    $0003, $0300, $1005); { CMP acum, immed }
    Put($0080,'CMP',    $000C, $0300, $10BD); { CMP reg, immed }
    Put($0038,'CMP',    $0090, $000C, $0405); { CMP memreg, reg }
    Put($003A,'CMP',    $000C, $0090, $2405); { CMP reg, memreg }
    Put($0080,'CMPB',   $0090, $0100, $10B9); { CMP memreg, immed8 (byte) }
    Put($00A6,'CMPSB',  $0400, $0400, $0001); { CMPS (byte) }
    Put($00A7,'CMPSW',  $0400, $0400, $0001); { CMPS (word) }
    Put($0081,'CMPW',   $0090, $0300, $10B9); { CMP memreg, immed16 (word) }
    Put($0099,'CWD',    $0400, $0400, $0001); { CWD }
    Put($0027,'DAA',    $0400, $0400, $0001); { DAA }
    Put($002F,'DAS',    $0400, $0400, $0001); { DAS }
    Put($0003,'DB',     $0900, $FFFF, $0000); { DB pseudo-op }
    Put($00FE,'DEC',    $0004, $0400, $0089); { DEC reg8 }
    Put($0048,'DEC',    $0008, $0400, $0041); { DEC reg16 }
    Put($00FE,'DECB',   $0090, $0400, $0089); { DEC memreg (byte) }
    Put($00FF,'DECW',   $0090, $0400, $0089); { DEC memreg (word) }
    Put($00F6,'DIV',    $0003, $0090, $20B5); { DIV acum, memreg }
    Put($0004,'DS',     $0300, $0500, $0000); { DS pseudo-op }
    Put($0006,'ENDP',   $FFFF, $FFFF, $0000); { ENDP pseudo-op }
    Put($0001,'EQU',    $0380, $0400, $0000); { EQU pseudo-op }
    Put($00F4,'HLT',    $0400, $0400, $0001); { HLT }

    { !! InitAsm 2.00, Mul, Div too ?! }
    Put($00F6,'IDIV',   { $0003}$009C, { $0090}$0400, $20BD); { IDIV acum, memreg }
    Put($00F6,'IMUL',   { $0003}$009C, { $0090}$0400, $20AD); { IMUL acum, memreg }
    Put($00EC,'IN',     $0001, $0008, $0001); { IN acum8, DX }
    Put($00ED,'IN',     $0002, $0008, $0001); { IN acum16, DX }
    Put($00E4,'IN',     $0003, $0100, $0805); { IN acum, port }
    Put($00FE,'INC',    $0004, $0400, $0081); { INC reg8 }
    Put($0040,'INC',    $0008, $0400, $0041); { INC reg16 }
    Put($00FE,'INCB',   $0090, $0400, $0081); { INC memreg (byte) }
    Put($00FF,'INCW',   $0090, $0400, $0081); { INC memreg (word) }
    Put($00CC,'INT',    $0400, $0400, $0001); { INT }
    Put($00CD,'INT',    $0100, $0400, $0801); { INT type }
    Put($00CE,'INTO',   $0400, $0400, $0001); { INTO }
    Put($00CF,'IRET',   $0400, $0400, $0001); { IRET }
    Put($0077,'JA',     $1000, $0400, $0101); { JA }
    Put($0073,'JAE',    $1000, $0400, $0101); { JAE }
    Put($0072,'JB',     $1000, $0400, $0101); { JB }
    Put($0076,'JBE',    $1000, $0400, $0101); { JBE }
    Put($00E3,'JCXZ',   $1000, $0400, $0101); { JCXZ }
    Put($0074,'JE',     $1000, $0400, $0101); { JE }
    Put($007F,'JG',     $1000, $0400, $0101); { JG }
    Put($007D,'JGE',    $1000, $0400, $0101); { JGE }
    Put($007C,'JL',     $1000, $0400, $0101); { JL }
    Put($007E,'JLE',    $1000, $0400, $0101); { JLE }
    Put($00EA,'JMP',    $0300, $0300, $1001); { JMP immed16, immed16 (addr) }
    Put($00E9,'JMP',    $1000, $0400, $0201); { JMP disp16 }
    Put($00FF,'JMPF',   $0090, $0400, $00A9); { JMPF [JMP mem (far)] }
    Put($00FF,'JMPN',   $0090, $0400, $00A1); { JMPN [JMP memreg (near)] }
    Put($00EB,'JMPS',   $1000, $0400, $0101); { JMP disp8 }
    Put($0075,'JNE',    $1000, $0400, $0101); { JNE }
    Put($0071,'JNO',    $1000, $0400, $0101); { JNO }
    Put($007B,'JNP',    $1000, $0400, $0101); { JNP }
    Put($0079,'JNS',    $1000, $0400, $0101); { JNS }
    Put($0075,'JNZ',    $1000, $0400, $0101); { JNZ }
    Put($0070,'JO',     $1000, $0400, $0101); { JO }
    Put($007A,'JP',     $1000, $0400, $0101); { JP(e) }
    Put($007A,'JPE',    $1000, $0400, $0101); { JPE }
    Put($007B,'JPO',    $1000, $0400, $0101); { JPO }
    Put($0078,'JS',     $1000, $0400, $0101); { JS }
    Put($0074,'JZ',     $1000, $0400, $0101); { JZ }
    Put($009F,'LAHF',   $0400, $0400, $0001); { LAHF }
    Put($00C5,'LDS',    $0008, $0090, $2401); { LDS reg, mem }
    Put($008D,'LEA',    $0008, $0090, $2401); { LEA reg, mem }
    Put($00C4,'LES',    $0008, $0090, $2401); { LES reg, mem }
    Put($00F0,'LOCK',   $0400, $0400, $0001); { LOCK }
    Put($00AC,'LODSB',  $0400, $0400, $0001); { LODSB }
    Put($00AD,'LODSW',  $0400, $0400, $0001); { LODSW }
    Put($00E2,'LOOP',   $1000, $0400, $0101); { LOOP }
    Put($00E1,'LOOPE',  $1000, $0400, $0101); { LOOPE }
    Put($00E0,'LOOPNE', $1000, $0400, $0101); { LOOPNE }
    Put($00E0,'LOOPNZ', $1000, $0400, $0101); { LOOPNZ }
    Put($00E1,'LOOPZ',  $1000, $0400, $0101); { LOOPZ }
    Put($00A0,'MOV',    $0003, $0080, $4005); { MOV acum, mem }
    Put($00A2,'MOV',    $0080, $0003, $4005); { MOV mem, acum }
    Put($008A,'MOV',    $000C, $0090, $2405); { MOV reg, memreg }
    Put($0088,'MOV',    $0090, $000C, $0405); { MOV memreg, reg }
    Put($00B8,'MOV',    $0008, $0300, $1041); { MOV reg16, immed16 }
    Put($00B0,'MOV',    $0004, $0100, $1041); { MOV reg8, immed8 }
    Put($008E,'MOV',    $0040, $0090, $2401); { MOV seg, memreg }
    Put($008C,'MOV',    $0090, $0060, $0401); { MOV memreg, seg(or cs) }
    Put($00C6,'MOVB',   $0090, $0100, $1081); { MOV memreg, immed8 }
    Put($00A4,'MOVSB',  $0400, $0400, $0001); { MOVSB }
    Put($00A5,'MOVSW',  $0400, $0400, $0001); { MOVSW }
    Put($00C7,'MOVW',   $0090, $0300, $1081); { MOV memreg, immed16 }
    Put($00F6,'MUL',    $0003, $0090, $20A5); { MUL acum, memreg }
    Put($00F6,'NEG',    $000C, $0400, $009D); { NEG reg }
    Put($00F6,'NEGB',   $0090, $0400, $0099); { NEG memreg (byte) }
    Put($00F7,'NEGW',   $0090, $0400, $0099); { NEG memreg (word) }
    Put($0090,'NOP',    $0400, $0400, $0001); { NOP }
    Put($00F6,'NOT',    $000C, $0400, $0095); { NOT reg }
    Put($00F6,'NOTB',   $0090, $0400, $0091); { NOT memreg (byte) }
    Put($00F7,'NOTW',   $0090, $0400, $0091); { NOT memreg (word) }
    Put($000C,'OR',     $0003, $0300, $1005); { OR acum, immed }
    Put($0080,'OR',     $000C, $0300, $108D); { OR reg, immed }
    Put($0008,'OR',     $0090, $000C, $0405); { OR memreg, reg }
    Put($000A,'OR',     $000C, $0090, $2405); { OR reg, memreg }
    Put($0080,'ORB',    $0090, $0100, $1089); { OR memreg, immed8 (byte) }
    Put($0002,'ORG',    $0300, $0400, $0000); { ORG pseudo-op }
    Put($0081,'ORW',    $0090, $0300, $1089); { OR memreg, immed16 (word) }
    Put($00EE,'OUT',    $0008, $0001, $0001); { OUT DX, acum8 }
    Put($00EF,'OUT',    $0008, $0002, $0001); { OUT DX, acum16 }
    Put($00E6,'OUT',    $0100, $0003, $0805); { OUT port, acum }
    Put($0058,'POP',    $0008, $0400, $0041); { POP reg16 }
    Put($008F,'POP',    $0090, $0400, $0081); { POP memreg }
    Put($0007,'POP',    $0040, $0400, $0041); { POP seg }
    Put($009D,'POPF',   $0400, $0400, $0001); { POPF }
    Put($0005,'PROC',   $3000, $0400, $0000); { PROC pseudo-op }
    Put($0050,'PUSH',   $0008, $0400, $0041); { PUSH reg16 }
    Put($00FF,'PUSH',   $0090, $0400, $00B1); { PUSH memreg (word) }
    Put($0006,'PUSH',   $0060, $0400, $0041); { PUSH seg (or CS) }
    Put($009C,'PUSHF',  $0400, $0400, $0001); { PUSHF }
    Put($00D0,'RCL',    $000C, $4400, $8095); { RCL reg }
    Put($00D0,'RCLB',   $0090, $4400, $8091); { RCL memreg (byte) }
    Put($00D1,'RCLW',   $0090, $4400, $8091); { RCL memreg (word) }
    Put($00D0,'RCR',    $000C, $4400, $809D); { RCR reg }
    Put($00D0,'RCRB',   $0090, $4400, $8099); { RCR memreg (byte) }
    Put($00D1,'RCRW',   $0090, $4400, $8099); { RCR memreg (word) }
    Put($00F3,'REP',    $0400, $0400, $0001); { REP }
    Put($00F3,'REPE',   $0400, $0400, $0001); { REPE }
    Put($00F2,'REPNE',  $0400, $0400, $0001); { REPNE }
    Put($00F2,'REPNZ',  $0400, $0400, $0001); { REPNZ }
    Put($00F3,'REPZ',   $0400, $0400, $0001); { REPZ }
    Put($00CB,'RET',    $0400, $2000, $0001); { RET (far) }
    Put($00C3,'RET',    $0400, $1000, $0001); { RET (near) }
    Put($00CA,'RET',    $0300, $2000, $1001); { RET disp16 (far) }
    Put($00C2,'RET',    $0300, $1000, $1001); { RET disp16 (near) }
    Put($00D0,'ROL',    $000C, $4400, $8085); { ROL reg }
    Put($00D0,'ROLB',   $0090, $4400, $8081); { ROL memreg (byte) }
    Put($00D1,'ROLW',   $0090, $4400, $8081); { ROL memreg (word) }
    Put($00D0,'ROR',    $000C, $4400, $808D); { ROR reg }
    Put($00D0,'RORB',   $0090, $4400, $8089); { ROR memreg (byte) }
    Put($00D1,'RORW',   $0090, $4400, $8089); { ROR memreg (word) }
    Put($009E,'SAHF',   $0400, $0400, $0001); { SAHF }
    Put($00D0,'SAR',    $000C, $4400, $80BD); { SAR reg }
    Put($00D0,'SARB',   $0090, $4400, $80B9); { SAR memreg (byte) }
    Put($00D1,'SARW',   $0090, $4400, $80B9); { SAR memreg (word) }
    Put($001C,'SBB',    $0003, $0300, $1005); { SBB acum, immed }
    Put($0080,'SBB',    $000C, $0300, $109D); { SBB reg, immed }
    Put($0018,'SBB',    $0090, $000C, $0405); { SBB memreg, reg }
    Put($001A,'SBB',    $000C, $0090, $2405); { SBB reg, memreg }
    Put($0080,'SBBB',   $0090, $0100, $1099); { SBB memreg, immed8 (byte) }
    Put($0081,'SBBW',   $0090, $0300, $1099); { SBB memreg, immed16 (word) }
    Put($00AE,'SCASB',  $0400, $0400, $0001); { SCAS (byte) }
    Put($00AF,'SCASW',  $0400, $0400, $0001); { SCAS (word) }
    Put($0026,'SEG',    $0060, $0400, $0041); { SEG }
    Put($00D0,'SHL',    $000C, $4400, $80A5); { SHL reg }
    Put($00D0,'SHLB',   $0090, $4400, $80A1); { SHL memreg (byte) }
    Put($00D1,'SHLW',   $0090, $4400, $80A1); { SHL memreg (word) }
    Put($00D0,'SHR',    $000C, $4400, $80AD); { SHR reg }
    Put($00D0,'SHRB',   $0090, $4400, $80A9); { SHR memreg (byte) }
    Put($00D1,'SHRW',   $0090, $4400, $80A9); { SHR memreg (word) }
    Put($00F9,'STC',    $0400, $0400, $0001); { STC }
    Put($00FD,'STD',    $0400, $0400, $0001); { STD }
    Put($00FB,'STI',    $0400, $0400, $0001); { STI }
    Put($00AA,'STOSB',  $0400, $0400, $0001); { STOS (byte) }
    Put($00AB,'STOSW',  $0400, $0400, $0001); { STOS (word) }
    Put($002C,'SUB',    $0003, $0300, $1005); { SUB acum, immed }
    Put($0080,'SUB',    $000C, $0300, $10AD); { SUB reg, immed }
    Put($0028,'SUB',    $0090, $000C, $0405); { SUB memreg, reg }
    Put($002A,'SUB',    $000C, $0090, $2405); { SUB reg, memreg }
    Put($0080,'SUBB',   $0090, $0100, $10A9); { SUB memreg, immed8 (byte) }
    Put($0081,'SUBW',   $0090, $0300, $10A9); { SUB memreg, immed16 (word) }
    Put($00A8,'TEST',   $0003, $0300, $1005); { TEST acum, immed }
    Put($00F6,'TEST',   $000C, $0300, $1085); { TEST reg, immed }
    Put($0084,'TEST',   $0090, $000C, $0405); { TEST memreg, reg }
    Put($0084,'TEST',   $000C, $0090, $2405); { TEST reg, memreg }
    Put($00F6,'TESTB',  $0090, $0100, $1081); { TEST memreg, immed8 (byte) }
    Put($00F7,'TESTW',  $0090, $0300, $1081); { TEST memreg, immed16 (word) }
    Put($009B,'WAIT',   $0400, $0400, $0001); { WAIT }
    Put($0090,'XCHG',   $0008, $0400, $0041); { XCHG reg16 }
    Put($0090,'XCHG',   $0002, $0008, $2041); { XCHG acum16, reg16 }
    Put($0086,'XCHG',   $0090, $000C, $0405); { XCHG memreg, reg }
    Put($0086,'XCHG',   $000C, $0090, $2405); { XCHG reg, memreg }
    Put($00D7,'XLAT',   $0400, $0400, $0001); { XLAT }
    Put($0034,'XOR',    $0003, $0300, $1005); { XOR acum, immed }
    Put($0030,'XOR',    $0090, $000C, $0405); { XOR memreg, reg }
    Put($0032,'XOR',    $000C, $0090, $2405); { XOR reg, memreg }
    Put($0080,'XOR',    $000C, $0300, $10B5); { XOR reg, immed }
    Put($0080,'XORB',   $0090, $0100, $10B1); { XOR memreg, immed8 (byte) }
    Put($0081,'XORW',   $0090, $0300, $10B1); { XOR memreg, immed16 (word) }
  end;
end; { InitAsmTable }

end.